//LCD Functions Developed by electroSome
// defines added by willy
#define _XTAL_FREQ  4000000L     // 4MHz clock
#define DelayUs(x) _delay((unsigned long)((x)*(_XTAL_FREQ/4000000.0)))
#define DelayMs(x) _delay((unsigned long)((x)*(_XTAL_FREQ/4000.0)))


//BEGIN DEFINITIONS OF B PORT. USED TO DRIVE THE LCD DISPLAY WITH RB0 TO RB5
// AND THE ICSP WITH RB6 & RB7.
//#define D4 RB0  // LCD PIN 11 TO CHIP PIN 33  // JUST TO SHOW PIN USAGE
//#define D5 RB1  // LCD PIN 12 TO CHIP PIN 34  // JUST TO SHOW PIN USAGE
//#define D6 RB2  // LCD PIN 13 TO CHIP PIN 35  // JUST TO SHOW PIN USAGE
//#define D7 RB3  // LCD PIN 14 TO CHIP PIN 36  // JUST TO SHOW PIN USAGE
#define RS RB4  // LCD PIN 4 TO CHIP PIN 21
#define EN RB5  // LCD PIN 6 TO CHIP PIN 22
//#define CLK RB6  // CHIP PIN 39 TO ICSP CLOCK // JUST TO SHOW PIN USAGE
//#define DAT RB7  // CHIP PIN 40 TO ICSP DATA  // JUST TO SHOW PIN USAGE

void Lcd_Port(char a)
{
    if(a & 1)
        RB0 = 1;
    else
        RB0 = 0;

    if(a & 2)
        RB1 = 1;
    else
        RB1 = 0;

    if(a & 4)
        RB2 = 1;
    else
        RB2 = 0;

    if(a & 8)
        RB3 = 1;
    else
        RB3 = 0;
}
void Lcd_Cmd(char a)
{
    RS = 0;             // => RS = 0
    Lcd_Port(a);
    EN  = 1;             // => E = 1
    DelayMs(4);
    EN  = 0;             // => E = 0
}

Lcd_Clear()
{
    Lcd_Cmd(0);
    Lcd_Cmd(1);
}

void Lcd_Set_Cursor(char a, char b)
{
    char temp,z,y;
    if(a == 1)
    {
        temp = 0x80 + b - 1;
        z = temp>>4;
        y = temp & 0x0F;
        Lcd_Cmd(z);
        Lcd_Cmd(y);
    }
    else if(a == 2)
    {
        temp = 0xC0 + b - 1;
        z = temp>>4;
        y = temp & 0x0F;
        Lcd_Cmd(z);
        Lcd_Cmd(y);
    }
}

void Lcd_Init()
{
    Lcd_Port(0x00);
    DelayMs(20);
    Lcd_Cmd(0x03);
    DelayMs(5);
    Lcd_Cmd(0x03);
    DelayMs(11);
    Lcd_Cmd(0x03);
    /////////////////////////////////////////////////////
    Lcd_Cmd(0x02);
    Lcd_Cmd(0x02);
    Lcd_Cmd(0x08);
    Lcd_Cmd(0x00);
    Lcd_Cmd(0x0C);
    Lcd_Cmd(0x00);
    Lcd_Cmd(0x06);
}

void Lcd_Write_Char(char a)
{
    char temp,y;
    temp = a&0x0F;
    y = a&0xF0;
    RS = 1;             // => RS = 1
    Lcd_Port(y>>4);             //Data transfer
    EN = 1;
    DelayUs(40);
    EN = 0;
    Lcd_Port(temp);
    EN = 1;
    DelayUs(40);
    EN = 0;
    }

void Lcd_Write_String(const char *a)
{
    int i;
    for(i=0;a[i]!='\0';i++) Lcd_Write_Char(a[i]);
}

void Lcd_Shift_Right()
{
    Lcd_Cmd(0x01);
    Lcd_Cmd(0x0C);
}

void Lcd_Shift_Left()
{
    Lcd_Cmd(0x01);
    Lcd_Cmd(0x08);
}

